<mat-expansion-panel [expanded]="true">
  <mat-expansion-panel-header>
    <mat-panel-title>
      <span *ngIf="(editMode$ | async) else newTrainingTitle">Linear Training Instance</span>
      <ng-template #newTrainingTitle>Create Linear Training Instance</ng-template>
    </mat-panel-title>
    <mat-panel-description>
      <span>{{ tiTitle$ | async }}</span>
      <span class="spacer"></span>
      <div class="panel-description-error" *ngIf="!(canDeactivateTIEdit && canDeactivatePoolAssign)">
        <mat-icon color="warn">warning</mat-icon>
        <mat-error>Changes are not saved</mat-error>
      </div>
      <mat-icon>edit</mat-icon>
    </mat-panel-description>
  </mat-expansion-panel-header>
  <ng-template matExpansionPanelContent>
    <sentinel-controls [controls]="controls" (itemClicked)="onControlsAction($event)">
    </sentinel-controls>
    <mat-divider></mat-divider>
    <kypo-training-instance-edit
      (edited)="onTrainingInstanceChanged($event)"
      [hasStarted]="hasStarted$ | async"
      [trainingInstance]="trainingInstance$ | async"
      [editMode]="editMode$ | async">
    </kypo-training-instance-edit>

    <mat-divider></mat-divider>
    <!-- EDIT POOLS -->
    <div *ngIf="!(trainingInstance$ | async).localEnvironment && (trainingInstance$ | async) as trainingInstance">
      <div class="pools-header">
        <h3>Pools</h3>
        <mat-icon class="header-icon">view_module</mat-icon>
      </div>
      <kypo-pool-assign [selectedPoolId]="(trainingInstance$ | async).poolId"
                        [pools]="pools$ | async"
                        [hasStarted]="hasStarted$ | async"
                        [trainingInstanceId]="(trainingInstance$ | async).id"
                        (selectionChanged)="onPoolSelectionChanged($event)">
      </kypo-pool-assign>
    </div>
    <!-- EDIT SANDBOX DEFINITIONS -->
    <div *ngIf="(trainingInstance$ | async).localEnvironment && (trainingInstance$ | async) as trainingInstance">
      <div class="sandbox-definitions-header">
        <h3>Sandbox Definitions</h3>
        <mat-icon class="header-icon">view_module</mat-icon>
      </div>
      <kypo-sandbox-definition-assign [selectedSandboxDefinitionId]="(trainingInstance$ | async).sandboxDefinitionId"
                                      [sandboxDefinitions]="sandboxDefinitions$ | async"
                                      (selectionChanged)="onSandboxDefinitionSelectionChanged($event)">
      </kypo-sandbox-definition-assign>
    </div>
  </ng-template>
</mat-expansion-panel>

<!-- EDIT ORGANIZERS -->
<mat-expansion-panel *ngIf="(editMode$ | async)" [expanded]="editMode$ | async">
  <mat-expansion-panel-header>
    <mat-panel-title>Organizers</mat-panel-title>
    <mat-panel-description>
      <span class="spacer"></span>
      <div class="panel-description-error" *ngIf="!canDeactivateOrganizers">
        <mat-icon color="warn">warning</mat-icon>
        <mat-error>Organizers are not saved</mat-error>
      </div>
      <mat-icon>person</mat-icon>
    </mat-panel-description>
  </mat-expansion-panel-header>
  <ng-template matExpansionPanelContent>
    <sentinel-user-assign *ngIf="editMode$ | async"
                       resourceMatIcon="event_available"
                       (hasUnsavedChanges)="onOrganizersChanged($event)"
                       [resource]="trainingInstance$ | async"
                       [defaultPaginationSize]="defaultPaginationSize"
                       toAssignTitle="Organizers"
                       assigneesTitle="Organizers">
    </sentinel-user-assign>
  </ng-template>
</mat-expansion-panel>
